100 REMark  Rudolph Christmas Adventure, by Dilwyn Jones
110 REMark **********************************************
120 REMark                ADVENTURE SHELL
130 REMark **********************************************
140 REMark                by Tim Hartnell
150 REMark             Interface publications
160 REMark **********************************************
170 REMark       Converted to QL BASIC and enhanced
180 REMark             by David Denham, 2017
190 REMark **********************************************
200 REMark v1.0 (QL)
210 :
220 REMark **********************************************
230 REMark *            SET DISPLAY WINDOWS             *
240 REMark **********************************************
250 WINDOW #0,512,256,0,0
260 BORDER #0,1,2
270 PAPER #0,0 : INK #0,7 : CLS #0
280 :
290 RANDOMISE  : REMark ** BEST RANDOM NUMBERS WE CAN GET
300 :
310 REMark **********************************************
320 REMark * SET VARIABLES, MAP, MONSTERS, TREASURE ETC *
330 REMark **********************************************
340 INITIALISE : REMark ** SET VARIABLES ETC
350 :
360 REMark **********************************************
370 REMark * SHOW GAME TITLE AND ANY INTRODUCTORY TEXT  *
380 REMark **********************************************
390 CSIZE #0,2,0 : PRINT #0,TITLE$ : CSIZE #0,0,0
400 PRINT #0,\'by Dilwyn Jones, 2024'\\ : UNDER #0,0
410 SHOW_INTRODUCTORY_TEXT
420 :
430 REPeat GAME
440   REMark *********************************************
450   REMark * HAVE WE REACHED THE HIGHEST ROOM NUMBER?  *
460   REMark * IF SO, REPORT SUCCESSFUL COMPLETION       *
470   REMark *********************************************
480   IF ROOM = 10 THEN
490     REMark if we are in the reindeer shed and carrying the Golden Carrot we've won
500     FLAG = 0
510     FOR COUNTER = 1 TO 3
520       IF CARRIED(COUNTER) = 2 THEN FLAG = 1 : EXIT COUNTER
530     END FOR COUNTER
540     IF FLAG = 1 THEN
550       REMark we are at the exit point and carrying the Golden Carrot
560       QUIT_FLAG = 1 : REMark SUCCESFUL COMPLETION FLAG
570       EXIT GAME
580     END IF
590   END IF
600   :
610   IF QUIT_FLAG = 2 THEN EXIT GAME
620   :
630   REMark ********************************************
640   REMark *      DISPLAY THE ROOM DESCRIPTIONS       *
650   REMark ********************************************
660   DISPLAY_ROOM_DESCRIPTION
670   :
680   REMark ********************************************
690   REMark * NEXT LINE ACTIVATED IF OBJECT(S) IN ROOM *
700   REMark ********************************************
710   IF MAP(ROOM,5) > 0 OR MAP(ROOM,6) > 0 OR MAP(ROOM,7) > 0 THEN DESCRIBE_OBJECTS_IN_ROOM
720   :
730   REMark ********************************************
740   REMark * NEXT LINES ACTIVATED IF MONSTER IN ROOM  *
750   REMark *  THE MONSTER MAY ATTACK YOU AT RANDOM!   *
760   REMark ********************************************
770   IF MAP(ROOM,8) > 0 THEN
780     REMark ** >0 means there IS a monster in the room
790     RAN = RND(1 TO 3)
800     SELect ON RAN
810       =1 : PRINT #0,"** LOOK OUT!";
820       =2 : PRINT #0,"** BE CAREFUL!";
830       =3 : PRINT #0,"** OH OH!";
840     END SELect
850     PRINT #0," There is a";
860     IF MONSTER$(MAP(ROOM,8),1) INSTR "AEIOU" THEN PRINT #0,"n";
870     PRINT #0," ";MONSTER$(MAP(ROOM,8));" here!"
880     IF RND > .5 THEN
890       REMark ** 50% chance the monster might attack you in the room
900       PRINT #0,"The ";MONSTER$(MAP(ROOM,8));
910       RAN = RND(1 TO 3)
920       SELect ON RAN
930         =1 : PRINT #0," turns to face you."
940         =2 : PRINT #0," fancies human for dinner."
950         =3 : PRINT #0," goes to attack you!"
960       END SELect
970       REMark are we carrying repellant spray?
980       FOR COUNTER = 1 TO 3
990         IF CARRIED(COUNTER) = 3 THEN
1000           PRINT #0,'The ';MONSTER$(MAP(ROOM,8));' notices the Repellant Spray and runs away.'
1010           MAP(ROOM,8) = 0 : EXIT COUNTER
1020         END IF
1030       END FOR COUNTER
1040       IF MAP(ROOM,8) > 0 THEN
1050         REMark monster still there, small chance it kills you
1060         IF RND(1 TO 2) = 1 THEN
1070           RAN = RND(1 TO 3)
1080           SELect ON RAN
1090             =1 : PRINT #0,'But it thinks better of it and leaves you alone.'
1100             =2 : PRINT #0,'The ';MONSTER$(MAP(ROOM,8));' decides not to attack you'
1110             =3 : PRINT #0,'But feels tired and falls asleep instead.'
1120           END SELect
1130         ELSE
1140           REMark attacks you
1150           RAN = RND(1 TO 3)
1160           SELect ON RAN
1170             =1 : PRINT #0,'The ';MONSTER$(MAP(ROOM,8));' eats you. You die.'
1180             =2 : PRINT #0,'The ';MONSTER$(MAP(ROOM,8));' kills you.'
1190             =3 : PRINT #0,'After a fierce fight, you are killed.'
1200           END SELect
1210           QUIT_FLAG = 2 : REMark dead
1220         END IF
1230       END IF
1240       NEXT GAME
1250     ELSE
1260       REMark ** MONSTER DOES NOT ATTACK,SO RANDOMLY
1270       REMark ** PRINT A MESSAGE TO THAT EFFECT.
1280       IF RND > .3 THEN
1290         IF RND > .5 THEN PRINT #0,"Fortunately, t"; : ELSE PRINT #0,"T";
1300         PRINT #0,"he ";MONSTER$(MAP(ROOM,8));" ";
1310         RAN = RND(1 TO 3)
1320         SELect ON RAN
1330           =1 : PRINT #0,"does not notice you."
1340           =2 : PRINT #0,"ignores you."
1350           =3 : PRINT #0,"is asleep."
1360         END SELect
1370       END IF
1380     END IF
1390   END IF
1400   :
1410   REMark ********************************************
1420   REMark * SHOW LIST OFITEMS CARRIED PLUS THE VALUE *
1430   REMark ********************************************
1440   INVENTORY
1450   :
1460   REMark ********************************************
1470   REMark *  PARSER - NEXT LINES ACCEPT PLAYER INPUT *
1480   REMark ********************************************
1490   KW = 0 : REMark ** KEYWORD - EQUALS 1 IF UNDERSTOOD
1500   REPeat ENTER
1510     INPUT #0,\"What do you want to do ? ";USER_INPUT$
1520     USER_INPUT$ = TL$(USER_INPUT$) : REMark STRIP LEFT SPACES
1530     IF USER_INPUT$ <> "" THEN EXIT ENTER
1540     REMark BLANK INPUT
1550     IF RND > .5 THEN PRINT #0,"Huh?" : ELSE PRINT #0,"Eh?" : END IF
1560   END REPeat ENTER
1570   :
1580   SPACE = " " INSTR USER_INPUT$ : REMark BREAK UP BOTH WORDS
1590   IF SPACE = 0 THEN
1600     WORD1$ = USER_INPUT$ : WORD2$ = "" : REMark ONE WORD ONLY
1610   ELSE
1620     WORD1$ = USER_INPUT$(1 TO SPACE-1)                   : REMark FIRST WORD
1630     WORD2$ = TL$(USER_INPUT$(SPACE TO LEN(USER_INPUT$))) : REMark SECOND WORD/PHRASE IF GIVEN
1640   END IF
1650   :
1660   REMark ***********************************************************
1670   REMark *  TEST PARSER BY PRINTING BOTH WORDS IN < > BRACKETS     *
1680   REMark *  REMOVE THE REM STATEMENTS TO TEST PARSER               *
1690   REMark ***********************************************************
1700   REMark PRINT #0,"WORD 1:<";WORD1$;">"
1710   REMark PRINT #0,"WORD 2:<";WORD2$;">"
1720   REMark ***********************************************************
1730   :
1740   IF WORD2$ = "" THEN
1750     REMark *********************************************************
1760     REMark *    SINGLE WORD COMMANDS SUCH AS "HELP" AND "QUIT"     *
1770     REMark *********************************************************
1780     :
1790     IF WORD1$ == "HELP" THEN
1800       REMark ** HELP COMMAND - amend if you wish to provide HELP
1810       REMark PRINT #0,"You must be joking!"
1820       INK #0,RND(2 TO 7)
1830       PRINT #0,'To find the key to unlock the reindeer shed you may need to ask someone.'
1840       PRINT #0,'Beware of the bear and wolf. To save your life you need repellant.'
1850       PRINT #0,'To clear a snow drift, ypou need the shovel.'
1860       PRINT #0,'To unthaw the carrot you need something warming.'
1870       PRINT #0,'Take the Golden Carrot to Rudolph to finish the game.'
1880       PRINT #0,
1890       KW = 1
1900     END IF
1910     :
1920     IF WORD1$ == "QUIT" THEN
1930       REMark ** QUIT COMMAND
1940       KW = 1 : QUIT_FLAG = 4 : REMark QUIT MODE FLAG
1950       EXIT GAME : REMark PRINT CLOSING SUMMARY
1960     END IF
1970     :
1980     IF WORD1$ == "VOCAB" OR WORD1$ == "VOCABULARY" THEN
1990       REMark ** VOCABULARY COMMAND - EDIT THE LIST IN PROC "VOCABULARY"
2000       KW = 1 : VOCABULARY
2010     END IF
2020     :
2030     IF WORD1$ == "MAP" THEN
2040       REMark ** MAP COMMAND - EDIT THE PROCEDURE "SHOW_MAP" TO SUIT
2050       KW = 1 : SHOW_MAP
2060     END IF
2070     :
2080     IF ("INV" INSTR WORD1$) = 1 THEN
2090       REMark ** INVENTORY COMMAND - LIST ITEMS BEING CARRIED **
2100       KW = 1 : INVENTORY
2110     END IF
2120     :
2130     REMark *********************************************************
2140     REMark *  ADD ANY FURTHER SINGLE WORD COMMANDS HERE,USING THE  *
2150     REMark *  EXAMPLES ABOVE.                                      *
2160     REMark *********************************************************
2170     :
2180   ELSE
2190     REMark *********************************************************
2200     REMark *  TWO WORD VERB / NOUN COMMANDS ARE INTERPRETED HERE.  *
2210     REMark *********************************************************
2220     :
2230     REMark *********************************************************
2240     REMark *  NEXT LINES 'UNDERSTAND' USER INPUT.                  *
2250     REMark *  IF YOU PREFER,  CHANGE TO JUST TESTING FIRST 2 OR 3  *
2260     REMark *  LETTERS OF A WORD TO ALLOW ABBREVIATION OF COMMANDS  *
2270     REMark *  E.G. KI INSTEAD OF 'KILL', G INSTEAD OF 'GO'         *
2280     REMark *********************************************************
2290     :
2300     REMark ** NEXT LINE ACCEPTS 'ASK'
2310     IF WORD1$ == 'ASK' THEN
2320       KW = 1 : ASK_SOMEONE
2330     END IF
2340     :
2350     REMark ** NEXT LINE ACCEPTS 'USE' OR 'SHOVEL' TO SHOVEL SNOW
2360     IF (WORD1$ == 'USE' AND WORD2$ == 'SHOVEL') OR (WORD1$ == 'SHOVEL' AND WORD2$ == 'SNOW') THEN
2370       KW = 1 : SHOVEL_SNOW
2380     END IF
2390     :
2400     REMark ** NEXT LINE ACCEPTS 'USE HAIR DRYER' TO THAW OUT GOLDEN CARROT
2410     IF (WORD1$ == 'USE' AND WORD2$ == 'HAIR DRYER') OR (WORD1$ == 'THAW' AND WORD2$ == 'GOLDEN CARROT') THEN
2420       KW = 1 : THAW_GOLDEN_CARROT
2430     END IF
2440     :
2450     REMark ** NEXT LINE ACCEPTS 'RUN' OR 'GO' OR 'MOVE'
2460     IF WORD1$ == "GO" OR WORD1$ == "MOVE" OR WORD1$ == "RUN" OR WORD1$ == "WALK" THEN
2470       KW = 1 : MOVEMENT_ROUTINE
2480     END IF
2490     :
2500     REMark ** NEXT LINE ACCEPTS 'GET' OR 'TAKE' OR 'LIFT' OR 'GRAB'
2510     IF WORD1$ == "GET" OR WORD1$ == "TAKE" OR WORD1$ == "LIFT" OR WORD1$ == "GRAB" THEN
2520       KW = 1 : GET_OBJECTS_ROUTINE
2530     END IF
2540     :
2550     REMark ** NEXT LINE ACCEPTS 'DROP' 'PUT' OR 'LEAVE'
2560     IF WORD1$ == "DROP" OR WORD1$ == "PUT" OR WORD1$ == "LEAVE" THEN
2570       KW = 1 : DROP_OBJECTS_ROUTINE
2580     END IF
2590     :
2600     REMark ** NEXT LINE ACCEPTS 'UNLOCK' OR 'OPEN'
2610     REMark ** IF A DIRECTION GIVEN, UNLOCK THAT EXIT, BUT UNLOCK IN
2620     REMark ** BOTH DIRECTIONS
2630     IF WORD1$ == "UNLOCK" OR WORD1$ == "OPEN" THEN
2640       KW = 1 : UNLOCK_EXIT
2650     END IF
2660     :
2670     REMark *********************************************************
2680     REMark *   ADD ANY FURTHER TWO WORD COMMANDS HERE, USING THE   *
2690     REMark *   EXAMPLES ABOVE.                                     *
2700     REMark *********************************************************
2710     :
2720   END IF
2730   :
2740   REMark ***********************************************************
2750   REMark *  KW=1 MEANS KEYWORD UNDERSTOOD, 0 MEANS NOT UNDERSTOOD  *
2760   REMark ***********************************************************
2770   IF KW = 0 THEN
2780     REMark *****************************************
2790     REMark *  CHOOSE "I DON'T UNDERSTAND" MESSAGE  *
2800     REMark *****************************************
2810     RAN = RND(1 TO 3)
2820     SELect ON RAN
2830       =1 : PRINT #0,"It would not be wise to ";USER_INPUT$
2840       =2 : PRINT #0,"Only a fool would try to ";USER_INPUT$
2850       =3 : PRINT #0,"I don't understand ";USER_INPUT$
2860     END SELect
2870   END IF
2880   :
2890   PAUSE RND(15 TO 50)
2900   :
2910 END REPeat GAME
2920 :
2930 END_OF_GAME
2940 :
2950 REMark ********************************************
2960 REMark *  RESET BASIC WINDOWS AFTER RUNNING GAME  *
2970 REMark *  WHEN DEVELOPING THE GAME                *
2980 REMark ********************************************
2990 REMark IF NOT COMPILED THEN WTV 4 : REMark OR WMON 4 IF YOU PREFER
3000 STOP
3010 :
3020 DEFine PROCedure VOCABULARY
3030   REMark ********************************************
3040   REMark *  SHOW LIST OF WORDS PROGRAM UNDERSTANDS  *
3050   REMark ********************************************
3060   INK #0,RND(2 TO 7) : PRINT #0,"List of commands:"
3070   PRINT #0,"HELP QUIT VOCABULARY MAP INVENTORY ASK USE SHOVEL GO MOVE"
3080   PRINT #0,"RUN WALK GET TAKE LIFT GRAB DROP PUT LEAVE UNLOCK OPEN."
3090   INK #0,7
3100 END DEFine VOCABULARY
3110 :
3120 DEFine PROCedure MOVEMENT_ROUTINE
3130   LOCal EXIT_NO
3140   REMark ********************************************
3150   REMark * MOVEMENT ROUTINE - CHECK THE ROOM EXITS. *
3160   REMark ********************************************
3170   WORD2$ = LEFT$(WORD2$,1) : EXIT_NO = WORD2$ INSTR "nsew"
3180   IF EXIT_NO = 0 THEN PRINT #0,"Go where?" : RETurn
3190   IF MAP(ROOM,EXIT_NO) <= 0 THEN
3200     IF MAP(ROOM,EXIT_NO) < 0 THEN
3210       PRINT #0,"That exit is locked."
3220     ELSE
3230       PRINT #0,"You can't go that way."
3240     END IF
3250     RETurn
3260   END IF
3270   IF ROOM = 4 AND SNOW_BLOCKAGE = 1 AND EXIT_NO = 3 THEN
3280     REMark can't go east from Open Yard if blocked by snow
3290     PRINT #0,"The entrance to the hay barn is blocked by snow. You need to use a shovel to clear"\"the snow."
3300     RETurn
3310   END IF
3320   :
3330   REMark ** EXIT IN SPECIFIED DIRECTION LEADS TO WHICH
3340   REMark ** ROOM NUMBER? SET 'ROOM' TO NEW ROOM NUMBER
3350   ROOM = MAP(ROOM,EXIT_NO)
3360 END DEFine MOVEMENT_ROUTINE
3370 :
3380 DEFine PROCedure SHOVEL_SNOW
3390   IF ROOM = 4 AND SNOW_BLOCKAGE = 1 THEN
3400     REMark check if carrying shovel
3410     FLAG = 0
3420     FOR COUNTER = 1 TO 3
3430       IF CARRIED(COUNTER) = 5 THEN FLAG = 1 : EXIT COUNTER
3440     END FOR COUNTER
3450     IF FLAG = 1 THEN SNOW_BLOCKAGE = 0 : PRINT #0,'Snow blockage is now cleared.'
3460   END IF
3470 END DEFine SHOVEL_SNOW
3480 :
3490 DEFine PROCedure THAW_GOLDEN_CARROT
3500   IF ROOM = 7 AND CARROT_FROZEN = 1
3510     REMark check if carrying hair dryer
3520     FLAG = 0
3530     FOR COUNTER = 1 TO 3
3540       IF CARRIED(COUNTER) = 4 THEN FLAG = 1 : EXIT COUNTER
3550     END FOR COUNTER
3560     IF FLAG = 1 THEN CARROT_FROZEN = 0 : PRINT #0,'The carrot is now thawed out.'
3570   END IF
3580 END DEFine THAW_GOLDEN_CARROT
3590 :
3600 DEFine PROCedure UNLOCK_EXIT
3610   LOCal EXIT_NO, OBJ_NO, X, EXIT_TO
3620   REMark ********************************************
3630   REMark * IF CARRYING THE KEY (OBJECT 1),  AND THE *
3640   REMark * SPECIFIED EXIT IS A -VE NUMBER,UNLOCK IT *
3650   REMark * BY TURNING THE EXIT NUMBER +VE.          *
3660   REMark * THE 'D' ALLOWS 'UNLOCK/OPEN DOOR'        *
3670   REMark ********************************************
3680   WORD2$ = LEFT$(WORD2$,1) : EXIT_NO = WORD2$ INSTR 'nsewd'
3690   IF EXIT_NO = 0 THEN PRINT #0,"Eh?" : RETurn
3700   REMark ** check if first object (key) being carried
3710   OBJ_NO = 0
3720   FOR X = 1 TO 3
3730     IF CARRIED(X) = 1 THEN OBJ_NO = 1 : EXIT X : REMark ** KEY
3740   END FOR X
3750   IF OBJ_NO <> 1 THEN PRINT #0,"No key!" : RETurn
3760   IF MAP(ROOM,EXIT_NO) = 0 THEN PRINT #0,"No exit that way." : RETurn
3770   IF MAP(ROOM,EXIT_NO) > 0 THEN PRINT #0,"Not locked."       : RETurn
3780   REMark ** EXIT IS LOCKED, SO UNLOCK FROM BOTH SIDES
3790   REMark ** FIRST, THIS SIDE
3800   MAP(ROOM,EXIT_NO) = ABS(MAP(ROOM,EXIT_NO))
3810   REMark ** NOW OTHER SIDE, UNLOCK EXIT IN OPPOSITE DIRECTION
3820   EXIT_TO = MAP(ROOM,EXIT_NO)
3830   IF EXIT_NO = 1 OR EXIT_NO = 3 THEN
3840     MAP(EXIT_TO,EXIT_NO+1) = ABS(MAP(EXIT_TO,EXIT_NO+1))
3850   ELSE
3860     MAP(EXIT_TO,EXIT_NO-1) = ABS(MAP(EXIT_TO,EXIT_NO-1))
3870   END IF
3880 END DEFine UNLOCK_EXIT
3890 :
3900 DEFine PROCedure SHOW_MAP
3910   REMark ********************************************
3920   REMark * PRINT A SIMPLE TEXT MAP-EDIT AS REQUIRED *
3930   REMark * FOR YOUR ROOM PLAN,INCLUDE AS MUCH OR AS *
3940   REMark * LITTLE DETAIL AS YOU WANT TO INCLUDE.    *
3950   REMark * CHANGE COLOURS, FOR EXAMPLE TO HIGHLIGHT *
3960   REMark * ENTRY/EXIT/LOCKED/OBJECTS/MONSTERS ETC.  *
3970   REMark ********************************************
3980     INK #0,RND(3 TO 5)
3990     PRINT #0,"     6         1=Santa's Lounge       8=Hay Barn"
4000     PRINT #0,"     |         2=Mrs Claus's Lounge   9=Elves' Area"
4010     PRINT #0,"  2  5  11     3=Utility Room        10=Reindeer Shed"
4020     PRINT #0,"  |  |  |      4=Open Yard           11=Slurry Store"
4030     PRINT #0,"  1--4--8--10  5=Workshop"
4040     PRINT #0,"  |  |  |      6=Store Room"
4050     PRINT #0,"  3  7  9      7=Ice Cave"
4060     INK #0,7
4070 END DEFine SHOW_MAP
4080 :
4090 DEFine PROCedure INVENTORY
4100   LOCal COUNTER,DONE
4110   REMark ********************************************
4120   REMark * THE NEXT LINES CHECK TO SEE IF PLAYER IS *
4130   REMark * CARRYING ANYTHING AND THEN PRINT A LIST  *
4140   REMark ********************************************
4150   TOTAL = 0
4160   FOR COUNTER = 1 TO 3
4170     IF CARRIED(COUNTER) <> 0 THEN TOTAL = TOTAL + 1
4180   END FOR COUNTER
4190   :
4200   IF TOTAL > 0 THEN
4210     CASH = 0
4220     PRINT #0,\"You are carrying:";
4230     DONE = 0
4240     FOR COUNTER = 1 TO 3
4250       IF CARRIED(COUNTER) <> 0 THEN
4260         PRINT #0, OBJECT$(CARRIED(COUNTER));
4270         DONE = DONE + 1 : LIST_SEPARATOR DONE,TOTAL
4280       END IF
4290     NEXT COUNTER
4300       PRINT #0,
4310     END FOR COUNTER
4320     IF CASH > 0 THEN
4330       PRINT #0,TO 8;"Total value - ";CURRENCY$;STR$(CASH)
4340     END IF
4350   END IF
4360 END DEFine INVENTORY
4370 :
4380 DEFine PROCedure GET_OBJECTS_ROUTINE
4390   LOCal FLAG, COUNTER, OBJ_NO
4400   REMark ******************************************************
4410   REMark * GET OBJECTS ROUTINE - PICK UP OBJECT IF PRESENT    *
4420   REMark * AND YOU ARE NOT ALREADY CARRYING MAXIMUM NUMBER    *
4430   REMark * OF OBJECTS                                         *
4440   REMark ******************************************************
4450   REMark ** CHECK IN CASE ALREADY CARRYING MAXIMUM NUMBER OF OBJECTS (5)
4460   FLAG = 0 : REMark COUNT OF NUMBER OF OBJECTS BEING CARRIED
4470   FOR COUNTER = 1 TO 3
4480     IF CARRIED(COUNTER) <> 0 THEN FLAG = FLAG + 1
4490   NEXT COUNTER
4500   IF FLAG = 3 THEN PRINT #0,"You are already carrying three objects." : RETurn
4510   :
4520   REMark ******************************************************
4530   REMark *  CHECK IF ANYTHING IN ROOM WHICH CAN BE PICKED UP  *
4540   REMark ******************************************************
4550   IF (MAP(ROOM,5)>0)+(MAP(ROOM,6)>0)+(MAP(ROOM,7)>0) = 0 THEN
4560     REMark ** NOTHING IN THIS ROOM TO BE PICKED UP
4570     PRINT #0,"I see nothing to pick up." : RETurn
4580   END IF
4590   :
4600   IF ROOM = 7 AND CARROT_FROZEN = 1 THEN
4610     IF WORD2$ == 'GOLDEN CARROT' THEN
4620       IF MAP(ROOM,5) = 2 OR MAP(ROOM,6) = 2 OR MAP(ROOM,7) = 2 THEN
4630         PRINT #0,"The Golden Carrot is frozen solid. You must thaw it out before you can pick it up."
4640         RETurn
4650       END IF
4660     END IF
4670   END IF
4680   :
4690   REMark ******************************************************
4700   REMark *  NOW PICK IT UP (C$ IS NAME OF OBJECT TO PICK UP)  *
4710   REMark *  ONLY ONE OBJECT CAN BE PICKED UP AT A TIME EVEN   *
4720   REMark *  IF THERE IS MORE THAN ONE WITH THE SAME NAME!     *
4730   REMark ******************************************************
4740   IF WORD2$ == OBJECT$(MAP(ROOM,5)) AND MAP(ROOM,5) > 0 THEN
4750     OBJ_NO = MAP(ROOM,5) : MAP(ROOM,5) = 0 : REMark FIRST OBJECT
4760   ELSE
4770     IF WORD2$ == OBJECT$(MAP(ROOM,6)) AND MAP(ROOM,6) > 0 THEN
4780       OBJ_NO = MAP(ROOM,6) : MAP(ROOM,6) = 0 : REMark SECOND OBJECT
4790     ELSE
4800       IF WORD2$ == OBJECT$(MAP(ROOM,7)) AND MAP(ROOM,7) > 0 THEN
4810         OBJ_NO = MAP(ROOM,7) : MAP(ROOM,7) = 0 : REMark THIRD OBJECT
4820       ELSE
4830         PRINT #0,WORD2$;" is not here." : RETurn
4840       END IF
4850     END IF
4860   END IF
4870   :
4880   REMark ** FIND AN EMPTY SPACE IN PICKED-UP OBJECTS LIST
4890   FOR COUNTER = 1 TO 3
4900     IF CARRIED(COUNTER) = 0 THEN
4910       CARRIED(COUNTER) = OBJ_NO : EXIT COUNTER : REMark INSERT IN FIRST FREE SLOT IN LIST
4920     END IF
4930   END FOR COUNTER
4940   PRINT #0,TO 3;">-> You now have the ";OBJECT$(OBJ_NO)
4950 END DEFine GET_OBJECTS_ROUTINE
4960 :
4970 DEFine PROCedure DROP_OBJECTS_ROUTINE
4980   LOCal FLAG, COUNTER, OBJ_NO
4990   REMark ******************************************************
5000   REMark * DROP OBJECT ROUTINE - FIRST COUNT HOW MANY BEING   *
5010   REMark * CARRIED AT THE MOMENT (0 = NONE, 1 = AT LEAST ONE  *
5020   REMark ******************************************************
5030   FLAG = 0
5040   FOR COUNTER = 1 TO 3
5050     IF CARRIED(COUNTER) <> 0 THEN
5060       FLAG = 1 : EXIT COUNTER : REMark SOMETHING BEING CARRIED
5070     END IF
5080   END FOR COUNTER
5090   IF FLAG = 0 THEN
5100     REMark ** NOTHING CURRENTLY BEING CARRIED
5110     PRINT #0,"You are not carrying anything."
5120     RETurn
5130   END IF
5140   :
5150   REMark ** IS THE ROOM ALREADY FULL OF OBJECTS?
5160   IF (MAP(ROOM,5)<>0) + (MAP(ROOM,6)<>0) + (MAP(ROOM,7)<>0) = 3 THEN
5170     REMark ** ROOM CAN ONLY HOLD 3 OBJECTS
5180     PRINT #0,"This room already holds its maximum number of objects."
5190     RETurn
5200   END IF
5210   :
5220   REMark ** TRY TO MATCH NAME OF OBJECT TO BE DROPPED WITH ITEM IN LIST OF OBJECTS
5230   OBJECT_NAME$  = "" : REMark OBJECT NAME
5240   OBJ_NO        = 0  : REMark OBJECT NUMBER
5250   FOR COUNTER = 1 TO NO_OF_OBJECTS
5260     IF OBJECT$(COUNTER) == WORD2$ THEN
5270       OBJECT_NAME$ = OBJECT$(COUNTER) : OBJ_NO = COUNTER : EXIT COUNTER : REMark NAME MATCHED
5280     END IF
5290   END FOR COUNTER
5300   IF OBJECT_NAME$ = "" THEN
5310     REMark ** THAT OBJECT NOT CURRENTLY BEING CARRIED
5320     PRINT #0,"How can you when you're not holding it."
5330     RETurn
5340   END IF
5350   :
5360   FOR COUNTER = 1 TO 3
5370     IF CARRIED(COUNTER) = OBJ_NO THEN CARRIED(COUNTER) = 0 : REMark RESET CARRIED ITEM NUMBER
5380   END FOR COUNTER
5390   :
5400   REMark ** ADD TO AN UNUSED ROOM OBJECT NUMBER
5410   IF MAP(ROOM,5) = 0 THEN
5420     MAP(ROOM,5) = OBJ_NO : REMark ROOM OBJECT 1
5430   ELSE
5440     IF MAP(ROOM,6) = 0 THEN
5450       MAP(ROOM,6) = OBJ_NO : REMark ROOM OBJECT 2
5460     ELSE
5470       IF MAP(ROOM,7) = 0 THEN MAP(ROOM,7) = OBJ_NO : REMark ROOM OBJECT 3
5480     END IF
5490   END IF
5500   PRINT #0,"You have dropped the ";OBJECT_NAME$;"."
5510 END DEFine DROP_OBJECTS_ROUTINE
5520 :
5530 DEFine PROCedure ASK_SOMEONE
5540   REMark ask Mrs Claus or the Elves in their room about the key and it becomes visible
5550   IF (WORD2$ == 'MRS CLAUS' OR WORD2$ == 'MRS. CLAUS' OR WORD2$ == 'MRS.CLAUS' OR WORD2$ == 'HER') AND ROOM = 2 THEN
5560     MAP(9,5) = ABS(MAP(9,5)) : TELL_WHERE_IS_KEY : RETurn
5570   END IF
5580   IF (WORD2$ == 'ELVES' OR WORD2$ == 'THE ELVES' OR WORD2$ == 'ELF' OR WORD2$ == 'THEM' ) AND ROOM = 9 THEN
5590     MAP(9,5) = ABS(MAP(9,5)) : TELL_WHERE_IS_KEY : REMark make key visible after asking where it is
5600   END IF
5610 END DEFine ASK_SOMEONE
5620 :
5630 DEFine PROCedure TELL_WHERE_IS_KEY
5640   PRINT #0,"You are told that the key to the reindeer shed is in the elves' area."
5650 END DEFine TELL_WHERE_IS_KEY
5660 :
5670 DEFine PROCedure END_OF_GAME
5680   REMark *************************
5690   REMark *   END OF GAME REPORT  *
5700   REMark *************************
5710   PRINT
5720   SCORE = 0 : REMark ** SCORE
5730   SELect ON QUIT_FLAG
5740     =1 : REMark ** SUCCESSFUL COMPLETION
5750          DISPLAY_ROOM_DESCRIPTION
5760          RAN = RND(1 TO 3) : PRINT #0,
5770          SELect ON RAN
5780            =1 : PRINT #0,'Rudolph accepts the Golden Carrot and instantly feels better.'
5790            =2 : PRINT #0,'You feed the Golden Carrot to Rudolph and it cures him.'
5800            =3 : PRINT #0,"The Golden Carrot quickly restores Rudolph's health and his nose becomes red!"
5810          END SELect
5820          PRINT #0,"Rudolph can now haul the sled to deliver the presents to the world's children."
5830          PAUSE 25
5840          PRINT #0,\"CONGRATULATIONS... You have completed the '";TITLE$;"' adventure!!!"
5850          SCORE = 100
5860          PRINT
5870     =2 : REMark ** DEATH
5880          PRINT #0,\"You died. Hard luck."
5890     =4 : REMark ** "QUIT" COMMAND
5900          IF RND(1 TO 2) = 1 THEN
5910            PRINT #0,"I did not imagine you would turn out to be a quitter!"
5920          ELSE
5930            PRINT #0,"Oh, you chose to quit! Ah well, goodbye."
5940          END IF
5950          IF RND(1 TO 2) = 1 THEN PRINT #0,"Thank you for playing ";TITLE$
5960   END SELect
5970   PRINT #0,\'Program finished.'
5980   :
5990 END DEFine END_OF_GAME
6000 :
6010 DEFine PROCedure DISPLAY_ROOM_DESCRIPTION
6020   REMark *****************************************
6030   REMark *  ADD ROOM DESCRIPTIONS AS REQUIRED    *
6040   REMark *  NO DESCRIPTION REQUIRED FOR THE      *
6050   REMark *  HIGHEST ROOM NUMBER (THE EXIT ROOM)  *
6060   REMark *****************************************
6070   :
6080   INK #0,4
6090   PRINT #0,\"You are in ";
6100   :
6110   SELect ON ROOM
6120     =1 : REMark ** ROOM 1
6130          PRINT #0,"Santa's lounge";
6140          :
6150     =2 : REMark ** ROOM 2
6160          PRINT #0,"Mrs.Claus's lounge. She is here";
6170          :
6180     =3 : REMark ** ROOM 3
6190          PRINT #0,"the Utility room";
6200          :
6210     =4 : REMark ** ROOM 4
6220          PRINT #0,"an Open yard";
6230          :
6240     =5 : REMark ** ROOM 5
6250          PRINT #0,"the Workshop";
6260          :
6270     =6 : REMark ** ROOM 6
6280          PRINT #0,"a Store room";
6290          :
6300     =7 : REMark ** ROOM 7
6310          PRINT #0,"the Ice cave";
6320          :
6330     =8 : REMark ** ROOM 8
6340          PRINT #0,"the Hay barn";
6350          :
6360     =9 : REMark ** ROOM 9
6370          PRINT #0,"the Elves' area";
6380          :
6390     =10: REMark ** ROOM 10
6400          PRINT #0,"the Reindeer shed";
6410          :
6420     =11: REMark ** ROOM 11 (bit of a red herring)
6430          PRINT #0,'the slurry store (it smells in here)';
6440          :
6450   END SELect
6460   :
6470   REMark *****************************************
6480   REMark *  WHERE ARE THE EXITS FROM THIS ROOM?  *
6490   REMark *    FIRST COUNT THE NUMBER OF EXITS    *
6500   REMark *****************************************
6510   EXITS = (MAP(ROOM,1)<>0) + (MAP(ROOM,2)<>0) + (MAP(ROOM,3)<>0) + (MAP(ROOM,4)<>0)
6520   SELect ON EXITS
6530     =0 : REMark ** NO EXITS, SAY NOTHING! (SHOULDN'T HAPPEN)
6540     =1 : REMark ** ONE EXIT ONLY
6550          PRINT #0,", there is an exit ";
6560          FOR X = 1 TO 4
6570            IF MAP(ROOM,X) <> 0 THEN
6580              PRINT #0,DIRECTION$(X);
6590              LOCKED_OR_NOT ROOM,X : REMark PRINT" (locked)" if required
6600              PRINT #0,"."
6610            END IF
6620          END FOR X
6630     =REMAINDER : REMark ** MORE THAN ONE EXIT
6640          PRINT #0,", there are exits ";
6650          DONE = 0 : REMark how many printed so far
6660          IF MAP(ROOM,1) <> 0 THEN
6670            PRINT #0,"North"; : LOCKED_OR_NOT ROOM,1 : DONE = DONE + 1 : LIST_SEPARATOR DONE,EXITS
6680          END IF
6690          IF MAP(ROOM,2) <> 0 THEN
6700            PRINT #0,"South"; : LOCKED_OR_NOT ROOM,2 : DONE = DONE + 1 : LIST_SEPARATOR DONE,EXITS
6710          END IF
6720          IF MAP(ROOM,3) <> 0 THEN
6730            PRINT #0,"East";  : LOCKED_OR_NOT ROOM,3 : DONE = DONE + 1 : LIST_SEPARATOR DONE,EXITS
6740          END IF
6750          IF MAP(ROOM,4) <> 0 THEN
6760            PRINT #0,"West";  : LOCKED_OR_NOT ROOM,4 : DONE = DONE + 1
6770          END IF
6780          PRINT #0,"."
6790   END SELect
6800   INK #0,7
6810   :
6820 END DEFine DISPLAY_ROOM_DESCRIPTION
6830 :
6840 DEFine PROCedure LIST_SEPARATOR (ENTRY_NO,LIST_SIZE)
6850   REMark *****************************************
6860   REMark * INSERT "," / "AND" BETWEEN LIST ITEMS *
6870   REMark *****************************************
6880   IF ENTRY_NO < (LIST_SIZE-1) THEN
6890     PRINT #0,", ";
6900   ELSE
6910     IF ENTRY_NO = (LIST_SIZE-1) THEN PRINT #0," and ";
6920   END IF
6930 END DEFine LIST_SEPARATOR
6940 :
6950 DEFine PROCedure LOCKED_OR_NOT(ROOM_NUMBER,EXIT_NUMBER)
6960   REMark ****************************************
6970   REMark * INDICATE IF THIS EXIT LOCKED OR NOT  *
6980   REMark ****************************************
6990   IF MAP(ROOM_NUMBER,EXIT_NUMBER) < 0 THEN PRINT #0," (locked)";
7000 END DEFine LOCKED_OR_NOT
7010 :
7020 DEFine PROCedure SHOW_INTRODUCTORY_TEXT
7030   REMark ****************************************
7040   REMark * PRINT A GENERAL INTRODUCTION FOR THE *
7050   REMark * GAME HERE (OR MAY BE LEFT BLANK)     *
7060   REMark ****************************************
7070   INK #0,RND(4 TO 6)
7080   PRINT #0,"It is Christmas Eve at Santa's place. It is snowing heavily - there is a blizzard."
7090   PRINT #0,\'Rudolph the red nosed reindeer is not well. He has a heavy cold and his nose'
7100   PRINT #0,'is more blue from the cold than red. In fact, he is so unwell that he will be'
7110   PRINT #0,'unable to haul the sled to deliver the Christmas gifts to all of the children.'
7120   PRINT #0,\'Rudolph is locked in the reindeer shed and needs a magic golden carrot to'
7130   PRINT #0,'help him get better in time to haul the sled. You must find the Golden Carrot'
7140   PRINT #0,'and take it to him in order to make him better.'
7150   INK #0,7
7160 END DEFine SHOW_INTRODUCTORY_TEXT
7170 :
7180 DEFine PROCedure DESCRIBE_OBJECTS_IN_ROOM
7190   LOCal TOTAL,DONE
7200   REMark ****************************************
7210   REMark *  DESCRIBE OBJECTS SEEN IN THIS ROOM  *
7220   REMark *  FIRST,COUNT NUMBER OF OBJECTS HERE  *
7230   REMark ****************************************
7240   TOTAL = (MAP(ROOM,5) > 0) + (MAP(ROOM,6) > 0) + (MAP(ROOM,7) > 0)
7250   DONE = 0
7260   PRINT #0,"You can see :";
7270   IF MAP(ROOM,5) > 0 THEN PRINT #0,OBJECT$(MAP(ROOM,5)); : DONE = DONE + 1 : LIST_SEPARATOR DONE,TOTAL
7280   IF MAP(ROOM,6) > 0 THEN PRINT #0,OBJECT$(MAP(ROOM,6)); : DONE = DONE + 1 : LIST_SEPARATOR DONE,TOTAL
7290   IF MAP(ROOM,7) > 0 THEN PRINT #0,OBJECT$(MAP(ROOM,7));
7300   PRINT #0,
7310   PAUSE RND(25 TO 50)
7320 END DEFine DESCRIBE_OBJECTS_IN_ROOM
7330 :
7340 DEFine PROCedure INITIALISE
7350   REMark **************************************************************
7360   REMark * INITIALISE THE ADVENTURE MAP - ROOMS, OBJECTS AND MONSTERS *
7370   REMark * HEAVILY COMMENTED AS THIS IS CENTRAL TO THE PROGRAM.       *
7380   REMark **************************************************************
7390   LOCal X,Y,RAN,CHOOSE_EMPTY,OB_NO,TOTAL,INSERT_AT
7400   :
7410   RESTORE
7420   :
7430   REMark ** TITLE$ is the name of the adventure, as printed to screen
7440   READ TITLE$
7450   :
7460   REMark MAIN GAME ARRAYS:
7470   REMark   MAP() : ROOM PROPERTIES
7480   REMark   MAP(ROOM,1) - EXIT NORTH TO ROOM NUMBER (0=NO EXIT)
7490   REMark   MAP(ROOM,2) - EXIT SOUTH TO ROOM NUMBER (0=NO EXIT)
7500   REMark   MAP(ROOM,3) - EXIT EAST  TO ROOM NUMBER (0=NO EXIT)
7510   REMark   MAP(ROOM,4) - EXIT WEST  TO ROOM NUMBER (0=NO EXIT)
7520   REMark   MAP(ROOM,5) - OBJECT 1 IN THIS ROOM (0=NONE)
7530   REMark   MAP(ROOM,6) - OBJECT 2 IN THIS ROOM (0=NONE)
7540   REMark   MAP(ROOM,7) - OBJECT 3 IN THIS ROOM (0=NONE)
7550   REMark   MAP(ROOM,8) - MONSTER TYPE IN THIS ROOM (0=NONE)
7560   REMark
7570   REMark   CARRIED()   - ITEMS PICKED UP IF NON-ZERO
7580   REMark
7590   REMark   OBJECT$()   - OBJECT/TREASURE NAME
7600   REMark
7610   REMark   MONSTER$()  - NAMES OF MONSTERS
7620   REMark
7630   READ NO_OF_ROOMS    : REMark ** 1-n  (n=EXIT ROOM)
7640   READ ROOM           : REMark ** START IN THIS ROOM NUMBER
7650   READ NO_OF_OBJECTS  : REMark ** HOW MANY OBJECTS IN TOTAL
7660   READ NO_OF_MONSTERS : REMark ** TOTAL NUMBER OF MONSTERS
7670   :
7680   REMark ** ARRAYS USED TO HOLD DETAILS OF MAP, MONSTERS, OBJECTS ETC
7690   DIM MAP(NO_OF_ROOMS,8)          : REMark MAP OF ROOM EXITS
7700   DIM CARRIED(3)                  : REMark OBJECTS PICKED UP BY PLAYER
7710   DIM OBJECT$(NO_OF_OBJECTS,20)   : REMark OBJECT/TREASURE NAME
7720   DIM MONSTER$(NO_OF_MONSTERS,20) : REMark MONSTER NAME
7730   DIM DIRECTION$(4,10)            : REMark DIRECTION NAMES
7740   DIRECTION$(1) = 'Northward' : DIRECTION$(2) = 'Southward'
7750   DIRECTION$(3) = 'Eastward'  : DIRECTION$(4) = 'Westward'
7760   :
7770   QUIT_FLAG       = 1  : REMark ** END OF GAME FLAG (1=SUCCESS, 2=EXHAUSTION, 4=QUIT COMMAND)
7780   MONSTERS_KILLED = 0  : REMark ** MONSTERS KILLED
7790   WORD1$          = "" : REMark ** FIRST WORD OF 2-WORD USER ENTRIES
7800   WORD2$          = "" : REMark ** SECOND WORD OF 2-WORD USER ENTRIES
7810   SNOW_BLOCKAGE   = 1  : REMark ** BETWEEN LOCATIONS 4 AND 8
7820   CARROT_FROZEN   = 1  : REMark ** NEED TO THAW THE GOLDEN CARROT TO BE ABLE TO PICK IT UP
7830   :
7840   REMark ** SET UP ROOMS
7850   FOR X = 1 TO NO_OF_ROOMS
7860     FOR Y = 1 TO 4 : READ MAP(X,Y)
7870   END FOR X
7880   :
7890   REMark ** DISTRIBUTE TREASURE, BUT IF A KEY IS REQUIRED
7900   REMark ** PLACE IT FIRST, BEFORE ANY LOCKED DOOR IN THE
7910   REMark ** OBJECTS HELD IN ROOMS  MAP(N,5) TO MAP(N,7)
7920   REMark ** NEGATIVE OBJECT NUMBERS MAKE OBJECT INVISIBLE
7930   REMark ** (SO THAT ANOTHER ACTION NEEDED TO MAKE VISIBLE)
7940   REMark ** GET LIST OF OBJECT NAMES AND OBJECT VALUES
7950   FOR X = 1 TO NO_OF_OBJECTS : READ OBJECT$(X)
7960   :
7970   REMark ** PLACE KEY (OBJECT #1) IN SPECIFIED LOCATION
7980   REMark ** IF NOT USING LOCKED DOORS, OR NO KEY AT ALL
7990   REMark ** CHANGE LOOP TO for ob_no=1 to 8
8000   REMark ** REMEMBER KEY MUST BE *BEFORE* ANY LOCKED EXITS
8010   MAP(9,5) = -1 : REMark Key in Elves' area (Room 9) invisible until you ask Mrs Claus or Elves where it is
8020   MAP(7,5) = 2 : REMark Golden carrot in Ice cave (Room 7)
8030   MAP(3,5) = 3 : REMark Bear repellant in Utility room (Room 3)
8040   MAP(5,5) = 4 : REMark Hair dryer in Workshop (Room 5)
8050   MAP(6,5) = 5 : REMark Shovel in Store room (Room 6)
8060   TOTAL = 5 : REMark total of objects placed
8070   PRINT
8080   :
8090   REMark ** DISTRIBUTE MONSTERS AMONG ROOMS AT RANDOM
8100   READ MONSTER$(1),MONSTER$(2)
8110   REMark ** MONSTERS HELD IN ROOMS  MAP(N,8)
8120   REMark Polar bear or Arctic wolf may be in Open yard or Hay barn
8130   IF RND(1 TO 2) = 1 THEN
8140     MAP(4,8) = 1 : MAP(8,8) = 2
8150   ELSE
8160     MAP(4,8) = 2 : MAP(8,8) = 1
8170   END IF
8180 END DEFine INITIALISE
8190 :
8200 REMark ********************************************************
8210 REMark * GAME DATA FOLLOWS - TITLE, LIST OF ROOM CONNECTIONS, *
8220 REMark * STARTING ROOM NUMBER, OBJECT DATA, MONSTERS LIST     *
8230 REMark ********************************************************
8240 REMark
8250 REMark ************************************
8260 REMark *   TITLE OF THE ADVENTURE GAME    *
8270 REMark ************************************
8280 DATA "RUDOLPH IS ILL"
8290 :
8300 REMark ************************************
8310 REMark * ROOM DATA, FIRST VALUE IS NUMBER *
8320 REMark * NUMBER OF ROOMS, FOLLOWED BY THE *
8330 REMark * START ROOM NUMBER, FOLLOWED BY A *
8340 REMark * LIST OF EXITS  N,S,E,W FROM EACH *
8350 REMark * ROOM (0=NO EXIT,<>0 = LEADS TO A *
8360 REMark * ROOM NUMBER ( <0 = LOCKED DOOR). *
8370 REMark * A FINAL EXIT IS THE HIGHEST ROOM *
8380 REMark * NUMBER.                          *
8390 REMark * IF AN EXIT HAS A NEGATIVE VALUE, *
8400 REMark * IT'S A LOCKED DOOR, AND A KEY IS *
8410 REMark * NEEDED TO UNLOCK IT -  MAKE SURE *
8420 REMark * THAT THE KEY IS IN A ROOM BEFORE *
8430 REMark * A LOCKED DOOR, OR IT WILL NOT BE *
8440 REMark * POSSIBLE TO FIND THE KEY ! ALSO, *
8450 REMark * REMEMBER THAT LOCKED DOORS NEED  *
8460 REMark * -VE NUMBERS FROM BOTH SIDES !    *
8470 REMark * AS SUPPLIED, THE DOOR BETWEEN    *
8480 REMark * ROOMS 3 AND 16 IS LOCKED,AND THE *
8490 REMark * GAME STARTS FROM ROOM 1, ENDS 10 *
8500 REMark ************************************
8510 DATA 11 : REMark ** NUMBER OF ROOMS
8520 DATA 1  : REMark ** START ROOM NUMBER
8530 DATA 5  : REMark ** NUMBER OF OBJECTS
8540 DATA 2  : REMark ** NUMBER OF MONSTERS
8550 REMark ************************************
8560 REMark * MAP OF ROOMS, TO HELP UNDERSTAND *
8570 REMark * THE MAPPING SYSTEM.  GAME STARTS *
8580 REMark * ROOM 1,ENDS ROOM 10, LOCKED DOOR *
8590 REMark * BETWEEN ROOMS 8 AND 10,  THE KEY *
8600 REMark * IN ROOM 9 BUT HIDDEN UNTIL YOU   *
8610 REMark * ASK SOMEONE                      *
8620 REMark *                                  *
8630 REMark *            6                     *
8640 REMark *            |                     *
8650 REMark *         2  5  11                 *
8660 REMark *         |  |  |                  *
8670 REMark *         1--4--8--10              *
8680 REMark *         |  |  |                  *
8690 REMark *         3  7  9                  *
8700 REMark *                                  *
8710 REMark *                                  *
8720 REMark *                                  *
8730 REMark *                                  *
8740 REMark ************************************
8750 DATA 2,3,4,0   : REMark ** ROOM 1 Santa's lounge
8760 DATA 0,1,0,0   : REMark ** ROOM 2 Mrs Claus's lounge
8770 DATA 1,0,0,0   : REMark ** ROOM 3 Utility room
8780 DATA 5,7,8,1   : REMark ** ROOM 4 Open yard
8790 DATA 6,4,0,0   : REMark ** ROOM 5 Workshop
8800 DATA 0,5,0,0   : REMark ** ROOM 6 Store room
8810 DATA 4,0,0,0   : REMark ** ROOM 7 Ice cave
8820 DATA 11,9,-10,4: REMark ** ROOM 8 Hay barn
8830 DATA 8,0,0,0   : REMark ** ROOM 9 Elves' area
8840 DATA 0,0,0,-8  : REMark ** ROOM 10 Reindeer shed
8850 DATA 0,8,0,0   : REMark ** ROOM 11 Slurry pit
8860 :
8870 REMark ************************************
8880 REMark * OBJECTS DATA : NAME,VALUE,WEAPON *
8890 REMark ************************************
8900 DATA "Key"           : REMark OBJECT 1
8910 DATA "Golden carrot" : REMark OBJECT 2
8920 DATA "Repellant"     : REMark OBJECT 3
8930 DATA "Hair dryer"    : REMark OBJECT 4
8940 DATA "Shovel"        : REMark OBJECT 5
8950 :
8960 REMark ************************************
8970 REMark * MONSTER NAMES                    *
8980 REMark ************************************
8990 DATA "Polar bear","Arctic wolf"
9000 :
9010 REMark ***************************************************************
9020 REMark * STRING HANDLING FUNCTIONS FOR EASIER CONVERSION TO QL BASIC *
9030 REMark ***************************************************************
9040 :
9050 DEFine FuNction STR$(NUM)
9060   REMark CONVERT NUMERIC VALUE TO STRING
9070   LOCal T$
9080   T$ = NUM
9090   RETurn T$
9100 END DEFine STR$
9110 :
9120 DEFine FuNction LEFT$(S$,NUM)
9130   REMark RETURN 'NUM' CHARACTERS FROM START OF STRING
9140   IF NUM < 1 THEN RETurn ""
9150   IF NUM > LEN(S$) THEN RETurn S$
9160   RETurn S$(1 TO NUM)
9170 END DEFine LEFT$
9180 :
9190 DEFine FuNction MID$(S$,START,NUM)
9200   REMark RETURN 'NUM' CHARACTERS FROM SPECIFIED START POINT IN STRING
9210   IF START < 1 OR START > LEN(S$) THEN RETurn ""
9220   IF NUM < 1 THEN RETurn ""
9230   RETurn S$(START TO START+NUM-1)
9240 END DEFine MID$
9250 :
9260 DEFine FuNction TL$(S$)
9270   LOCal T$,N
9280   REMark STRIP SPACES FROM LEFT OF STRING
9290   T$ = ""
9300   FOR N = 1 TO LEN(S$)
9310     IF S$(N) <> " " THEN T$ = S$(N TO LEN(S$)) : EXIT N
9320   END FOR N
9330   RETurn T$
9340 END DEFine TL$
9350 :
9360 REMark ======================================================================
9370 REMark **    UTILITY DEVELOPMENT ROUTINES, NOT NEEDED IN FINAL VERSION     **
9380 REMark ======================================================================
9390 :
9400 DEFine PROCedure Sa
9410   QSAVE 'win1_adv_Rudolph' : SAVE  'win1_adv_Rudolph_bas'
9420 END DEFine Sa
9430 :
9440 DEFine PROCedure XTV
9450   OUTLN #0,FLIM_W(#0),FLIM_H(#0),0,0
9460   WINDOW FLIM_W(#0),FLIM_H(#0)-52,0,0 : WINDOW #2,FLIM_W(#0),FLIM_H(#0)-52,0,0 : WINDOW #0,FLIM_W(#0),52,0,FLIM_H(#0)-52
9470   BORDER #1,1,255 : BORDER #2,1,255 : BORDER #0,1,255
9480   CLS : CLS #2 : CLS #0
9490 END DEFine XTV
9500 :
9510 DEFine PROCedure XTV2
9520   OUTLN #0,FLIM_W(#0),FLIM_H(#0),0,0
9530   WINDOW FLIM_W(#0)/2,FLIM_H(#0)-52,0,0 : WINDOW #2,FLIM_W(#0)/2,FLIM_H(#0)-52,0,0 : WINDOW #0,FLIM_W(#0)/2,52,0,FLIM_H(#0)-52
9540   BORDER #1,1,255 : BORDER #2,1,255 : BORDER #0,1,255
9550   CLS : CLS #2 : CLS #0
9560 END DEFine XTV2
9570 :
9580 DEFine PROCedure XTV3
9590   OUTLN #0,FLIM_W(#0),FLIM_H(#0),0,0
9600   WINDOW 512,FLIM_H(#0)-52,0,0 : WINDOW #2,512,FLIM_H(#0)-52,0,0 : WINDOW #0,512,52,0,FLIM_H(#0)-52
9610   BORDER #1,1,255 : BORDER #2,1,255 : BORDER #0,1,255
9620   CLS : CLS #2 : CLS #0
9630 END DEFine XTV3
9640 :
9650 DEFine PROCedure TEST_MAP
9660   LOCal X,Y
9670   CLS: UNDER 1 : PRINT'MAP() 1     2     3     4     5     6     7     8' : UNDER 0
9680   FOR X = 1 TO NO_OF_ROOMS
9690     PRINT X;':';
9700     FOR Y = 1 TO 8
9710       PRINT TO Y*6;MAP(X,Y);
9720     END FOR Y
9730     PRINT
9740   END FOR X
9750 END DEFine TEST_MAP
